
// employee.cpp: implementation of the employee class.
//
//////////////////////////////////////////////////////////////////////

#include "employee.h"
#include <iostream>
#include <string>	// for string class
#include <iomanip>	// for setw width specifier in cout 

using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEmployee::CEmployee(string fn, string ln, int en) 
	: firstname(fn), lastname(ln), employee_num(en)
{
#if DEBUG
	cout << "Employee constructor" << endl;
#endif
}

CEmployee::~CEmployee()
{
#if DEBUG
	cout << "Employee destructor" << endl;
#endif
}

//////////////////////////////////////////////////////////////////////
// Print names
//////////////////////////////////////////////////////////////////////
void CEmployee::print_names()
{
	cout << firstname << " " << lastname;
}

//////////////////////////////////////////////////////////////////////
// Print Employee number
//////////////////////////////////////////////////////////////////////
void CEmployee::print_num()
{
	cout << setw(8) << employee_num;

}

//////////////////////////////////////////////////////////////////////
// Display Employee data
//////////////////////////////////////////////////////////////////////
void CEmployee::display()
{
	cout << "Employee :";
	print_num();
	cout << " : ";
	print_names();
	cout << endl;
}
