// employee.cpp: implementation of the employee class.
//
//////////////////////////////////////////////////////////////////////

#include "employee.h"
#include <iostream>
#include <string.h>	// for C string functions
#include <iomanip>	// for setw width specifier in cout 

using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEmployee::CEmployee(char *fn, char *ln, int en) 
	: firstname(0), lastname(0), employee_num(en)
{
#if DEBUG
	cout << "Employee constructor" << endl;
#endif
	firstname = new char[strlen(fn) + 1];
	if (firstname == 0)
	{	
		cerr << "Out of memory" << endl;
		exit(-1);
	}
	strcpy(firstname, fn);
	lastname = new char[strlen(ln) + 1];
	if (lastname == 0)
	{	
		cerr << "Out of memory" << endl;
		exit(-1);
	}
	strcpy(lastname, fn);


}

CEmployee::~CEmployee()
{
#if DEBUG
	cout << "Employee destructor" << endl;
#endif
	delete firstname;
	delete lastname;
}

//////////////////////////////////////////////////////////////////////
// Print names
//////////////////////////////////////////////////////////////////////
void CEmployee::print_names()
{
	cout << firstname << " " << lastname;

}

//////////////////////////////////////////////////////////////////////
// Print Employee number
//////////////////////////////////////////////////////////////////////
void CEmployee::print_num()
{
	cout << setw(8) << employee_num;

}

//////////////////////////////////////////////////////////////////////
// Display Employee data
//////////////////////////////////////////////////////////////////////
void CEmployee::display()
{
	cout << "Employee :";
	print_num();
	cout << " : ";
	print_names();
	cout << endl;
}
