#include "employee.h"
#include "fulltime.h"
#include "parttime.h"
#include <iostream>
#include <string>	// for string class
using namespace std;

//////////////////////////////////////////////////////////////////////
// Test program for employee class
//////////////////////////////////////////////////////////////////////

void main()
{
	CEmployee x("Bert", "Fegg", 123456);
	CEmployee y("Sally", "Smith", 987654);

	x.print_names();
	cout << endl;
	y.print_num();
	cout << endl;

	CEmployee *p = new CEmployee("Peter", "Perfect", 999999);
	p->display();
	delete p;
	cout << "\n==============================================" << endl;
		
	////////////////////////////////////////////////////////////////////
	// So far everything is as before
	// Now create Fulltime and Parttime employees
	////////////////////////////////////////////////////////////////////

	cout << "Full time worker" << endl;
	CFulltime ft("Albert", "Einstein", 665566);
	ft.print_names();	// We can use inherited methods
	cout << " - ";
	ft.print_num();
	cout << " - ";
	ft.showholidays();
	ft.display();		// we can use overidden methods
	cout << endl;

	cout << "Part time worker" << endl;
	CParttime pt("Richard", "Feynman", 183246, 16);
	pt.print_names();
	cout << ". ";
	pt.showhours();
	cout << "\n==============================================" << endl;

	////////////////////////////////////////////////////////////////////
	// Now show access using pointers
	// Create a pointer to an Employee
	////////////////////////////////////////////////////////////////////
	cout << "Now using a pointer to an employee" << endl;
	CEmployee *pe;	// pe points to Bert Fegg
	pe = &x;
	pe->display();
	cout << endl;

	// We can use an Employee pointer to point to  object that are instances
	// of the classes derived from the employee class
	pe = &ft;		// pe points to Albert Einstein
	pe->print_names(); //This is OK
	cout << endl;
	
	// We cannot use methods in the derived class. Next line causes and error on compiling
	// pe->showholidays();

	pe->display();	// calls base class display not derived so doesn't print holiday entitlement!!
	cout << endl;

	pe = &pt;		// pe points to Richard Feynman
	pe->display();
	cout << endl;	// didn't print hours worked!!

//  
//  Because pe is a pointer to an employee type when the program is compiled the 
//  compiler places a call to the  display function in the class CEmployee.
//  This is called STATIC BINDING. What we would like is the call to the 
//	display function be determined not when the program is compiled but when
//  the program is actually run.
//  We can only use the functions that are in the base class.
	
//	We need what is called dynamic binding. 
//  Where a pointer to a base class can point to objects of the derived classes and the 
//  functions in the derived class will be determined at the time the call is made (i.e. at
//  run time.

//  This will provide what is called polymorphic behaviour.

}