#include "employee.h"
#include "fulltime.h"
#include "parttime.h"
#include <iostream>
#include <string>	// for string class
using namespace std;

//////////////////////////////////////////////////////////////////////
// Test program for employee class
//////////////////////////////////////////////////////////////////////

void main()
{
	CEmployee x("Bert", "Fegg", 123456);
	CEmployee y("Sally", "Smith", 987654);


	x.display();
	cout << endl;
	
	y.display();
	cout << endl;

	CEmployee *emp = new CEmployee("Peter", "Perfect", 999999);
	emp->display();
	cout << endl;
	delete p;

	cout << "\n==============================================" << endl;

	////////////////////////////////////////////////////////////////////
	// So far everything is as before
	// Now create Fulltime and Parttime employees
	////////////////////////////////////////////////////////////////////

	cout << "Full time worker" << endl;
	CFulltime ft("Albert", "Einstein", 665566);
	ft.display(); // Because f is a Fulltime object the corerct display function is called
	cout << endl;

	cout << "Part time worker" << endl;
	CParttime pt("Richard", "Feynman", 183246, 16);
	pt.display(); // Because g is a Parttime object the corerct display function is called
	cout << endl;

	////////////////////////////////////////////////////////////////////
	// Now create pointer to an Employee
	////////////////////////////////////////////////////////////////////
	cout << "Now using a pointer to an employee" << endl;
	CEmployee *pe;	// pe points to Bert Fegg
	pe = &x;
	pe->display();
	cout << endl;

	pe = emp;		// pe points to Peter Perfect
	pe->display();
	cout << endl;

	// We can use an Employee pointer to point to  object that are instances
	// of the classes derived from the employee class
	pe = &ft;		// pe points to Albert Einstein
	pe->display();
	cout << endl;	// didn't print holiday entitlement!!

	pe = &pt;		// pe points to Richard Feynman
	pe->display();
	cout << endl;	// didn't print hours worked

//  By preceding the display function declaration with the virtual keyword
//  the system looks down the class hierarchy to find the 
//  appropriate function for the object that the pointer is pointing at.
//  This is POLYMORPHISM at work!	

//  The look up of the correct funtion call to make is done at run time and
//  is called DYNAMIC BINDING as opposed to static binding which the compiler
//  uses at when the program is compiled.


}